package services

import (
	"encoding/json"
	"fmt"
	"hongze/hz_crm_eta/global"
	"hongze/hz_crm_eta/utils"
)

// ListenSyncAdminFromCrm 从CRM系统中同步用户
func ListenSyncAdminFromCrm() {
	defer func() {
		if err := recover(); err != nil {
			fmt.Println("[ListenSyncAdminFromCrm]", err)
		}
	}()
	for {
		global.Rc.Brpop(utils.CACHE_SYNC_SYS_USER_FROM_CRM, func(b []byte) {
			var adminName string
			_ = json.Unmarshal(b, &adminName)
			_ = HandleSyncAdminFromCrm(utils.SOURCE_CRM_FLAG, adminName)
		})
	}
}

// ListenSyncAdminFromEta 从ETA系统中同步用户
func ListenSyncAdminFromEta() {
	defer func() {
		if err := recover(); err != nil {
			fmt.Println("[ListenSyncAdminFromEta]", err)
		}
	}()
	for {
		global.Rc.Brpop(utils.CACHE_SYNC_SYS_USER_FROM_ETA, func(b []byte) {
			var adminName string
			_ = json.Unmarshal(b, &adminName)
			_ = HandleSyncAdminFromCrm(utils.SOURCE_ETA_FLAG, adminName)
		})
	}
}

// ListenSyncRoleFromCrm 从CRM系统中同步角色
func ListenSyncRoleFromCrm() {
	defer func() {
		if err := recover(); err != nil {
			fmt.Println("[ListenSyncRoleFromCrm]", err)
		}
	}()
	global.Rc.LPush(utils.CACHE_SYNC_SYS_ROLE_FROM_CRM, "同步角色")
	for {
		global.Rc.Brpop(utils.CACHE_SYNC_SYS_ROLE_FROM_CRM, func(b []byte) {
			var roleName string
			_ = json.Unmarshal(b, &roleName)
			_ = HandleSyncSysRole(utils.SOURCE_CRM_FLAG, roleName)
		})
	}
}

// ListenSyncRoleFromEta 从ETA系统中同步角色
func ListenSyncRoleFromEta() {
	defer func() {
		if err := recover(); err != nil {
			fmt.Println("[ListenSyncRoleFromEta]", err)
		}
	}()
	for {
		global.Rc.Brpop(utils.CACHE_SYNC_SYS_ROLE_FROM_ETA, func(b []byte) {
			var roleName string
			_ = json.Unmarshal(b, &roleName)
			_ = HandleSyncSysRole(utils.SOURCE_ETA_FLAG, roleName)
		})
	}
}
